<template>
  <form
    :class="(process.form ? ' whirl duo':'')"
    @submit.prevent="validateBeforeSubmit('user')"
    data-vv-scope="user"
  >
    <div class="bg-gray-lighter px-3 py-2 my-3">Editar Perfil - Informações pessoais</div>
    <div class="card-body">
      <!-- NOME -->
      <div class="form-group row">
        <label class="col-md-2 col-form-label">Nome completo*</label>
        <div class="col-md-6">
          <input
            v-model="user.name"
            v-validate="'required'"
            :class="{'form-control':true, 'is-invalid': errors.has('user.name')}"
            type="text"
            name="name"
          >
          <span v-show="errors.has('user.name')" class="invalid-feedback">Informe seu nome</span>
        </div>
      </div>

      <!-- CPF -->
      <div class="form-group row">
        <label class="col-md-2 col-form-label">CPF*</label>
        <div class="col-md-6">
          <masked-input
            type="text"
            class="form-control"
            placeholder="CPF"
            v-model="user.cpf"
            :mask="mask.cpf"
          />
          <span v-show="errors.has('user.cpf')" class="invalid-feedback">Informe um CPF válido</span>
        </div>
      </div>

      <!-- EMAIL -->
      <div class="form-group row">
        <label class="col-md-2 col-form-label">E-mail*</label>
        <div class="col-md-6">
          <input
            v-model="user.email"
            v-validate="'required|email'"
            :class="{'form-control':true, 'is-invalid': errors.has('user.email')}"
            type="email"
            name="email"
          >
          <span v-show="errors.has('user.email')" class="invalid-feedback">Informe um e-mail válido</span>
        </div>
      </div>
    </div>

    <!-- ENDEREÇO -->
    <div class="bg-gray-lighter px-3 py-2 my-3">Editar Perfil - Informações endereço</div>
    <div :class="'card-body'+(process.cep ? ' whirl duo' : '')">
      <!-- CEP -->
      <div class="form-group row">
        <label class="col-md-2 col-form-label">CEP*</label>
        <div class="col-md-6">
          <masked-input
            v-model="user.address_zipcode"
            v-validate="'required|min:9|max:9'"
            :class="{'form-control':true, 'is-invalid': errors.has('user.address_zipcode')}"
            type="text"
            class="form-control"
            placeholder="CEP"
            :mask="mask.address_zipcode"
            name="address_zipcode"
            @input="consultCep()"
          />
          <span
            v-show="errors.has('user.address_zipcode')"
            class="invalid-feedback"
          >Informe um CEP válido</span>
        </div>
      </div>

      <!-- RUA -->
      <div class="form-group row">
        <label class="col-md-2 col-form-label">Endereço*/Número</label>
        <div class="col-md-6">
          <input
            v-model="user.address_street"
            v-validate="'required'"
            :class="{'form-control':true, 'is-invalid': errors.has('user.address_street')}"
            type="text"
            placeholder="Rua/Complemento"
            name="address_street"
          >
          <span v-show="errors.has('user.address_street')" class="invalid-feedback">Informe sua rua</span>
        </div>
      </div>

      <!-- BAIRRO -->
      <div class="form-group row">
        <label class="col-md-2 col-form-label">Bairro*</label>
        <div class="col-md-6">
          <input
            :disabled="cepFinish"
            v-model="user.address_neighborhood"
            v-validate="'required'"
            :class="{'form-control':true, 'is-invalid': errors.has('user.address_neighborhood')}"
            type="text"
            placeholder="Bairro/setor"
            name="address_neighborhood"
          >
          <span
            v-show="errors.has('user.address_neighborhood')"
            class="invalid-feedback"
          >Informe seu bairro/setor</span>
        </div>
      </div>

      <!-- CIDADE -->
      <div class="form-group row">
        <label class="col-md-2 col-form-label">Cidade*</label>
        <div class="col-md-6">
          <input
            :disabled="cepFinish"
            v-model="user.address_city"
            v-validate="'required'"
            :class="{'form-control':true, 'is-invalid': errors.has('user.address_city')}"
            type="text"
            placeholder="Cidade"
            name="address_city"
          >
          <span v-show="errors.has('user.address_city')" class="invalid-feedback">Informe sua cidade</span>
        </div>
      </div>

      <!-- ESTADO -->
      <div class="form-group row">
        <label class="col-md-2 col-form-label">UF*</label>
        <div class="col-md-6">
          <select
            :disabled="cepFinish"
            class="custom-select-d custom-select-sm"
            v-model="user.address_state"
            v-validate="'required'"
            :class="{'form-control':true, 'is-invalid': errors.has('user.address_state')}"
          >
            <option v-for="uf in ufs" :key="uf" :value="uf">{{uf}}</option>
          </select>
          <span
            v-show="errors.has('user.address_state')"
            class="invalid-feedback"
          >Informe seu estado</span>
        </div>
      </div>
    </div>
    <!-- INFORMACOES BANCARIAS -->
    <div class="bg-gray-lighter px-3 py-2 my-3">Editar Perfil - Informações bancárias</div>
    <div class="card-body">
      <!-- BANCO -->
      <div class="form-group row">
        <label class="col-md-2 col-form-label">Banco*</label>
        <div class="col-md-6">
          <select
            class="custom-select-d custom-select-sm"
            v-model="user.bank.bank_id"
            v-validate="'required|is_not:0'"
            :class="{'form-control':true, 'is-invalid': errors.has('user.bank.bank_id')}"
          >
            <option
              v-for="bank in banks"
              :key="bank.bank_id"
              :value="bank.bank_id"
            >{{bank.bank_name+' ('+bank.bank_number+')'}}</option>
          </select>
          
          <span
            v-show="errors.has('user.bank.bank_id')"
            class="invalid-feedback"
          >Selecione o seu banco</span>
        </div>
      </div>

      <!-- NUMERO DA CONTA / DIGITO -->
      <div class="form-group row">
        <label class="col-md-2 col-form-label">Conta*/dígito</label>
        <div class="col-md-6">
          <b-input-group>
            <b-form-input
              v-model="user.bank.account"
              v-validate="'required'"
              :class="{'form-control':true, 'is-invalid': errors.has('user.bank.account')}"
              type="text"
              placeholder="Número da conta"
              name="bank.account"
            ></b-form-input>
            <b-form-input
              v-model="user.bank.account_digit"
              :class="{'form-control':true}"
              type="text"
              placeholder="Dígito da conta"
              name="account_digit"
            ></b-form-input>
          </b-input-group>
          <span
            v-show="errors.has('user.bank.account')"
            class="invalid-feedback"
          >Informe o número da conta</span>
        </div>
      </div>

      <!-- NUMERO DA AGENCIA / DIGITO -->
      <div class="form-group row">
        <label class="col-md-2 col-form-label">Agencia*/dígito</label>
        <div class="col-md-6">
          <b-input-group>
            <b-form-input
              v-model="user.bank.agency"
              v-validate="'required'"
              :class="{'form-control':true, 'is-invalid': errors.has('user.bank.agency')}"
              type="text"
              placeholder="Agencia da conta"
              name="bank.agency"
            ></b-form-input>
            <b-form-input
              v-model="user.bank.agency_digit"
              :class="{'form-control':true}"
              type="text"
              placeholder="Dígito da agência"
              name="agency_digit"
            ></b-form-input>
          </b-input-group>
          <span
            v-show="errors.has('user.bank.agency')"
            class="invalid-feedback"
          >Informe a agência da conta</span>
        </div>
      </div>

      <!--
      <fieldset v-if="user.id != 0">
        <div class="form-group row mb-2">
          <label class="col-md-2 col-form-label mb-2">Perfil</label>
          <div class="col-md-10">
            <p class="mt-3">Selecione os perfis para este usuário</p>
            <multiselect
              v-model="user.roles"
              :options="roles"
              :multiple="true"
              :close-on-select="false"
              :clear-on-select="false"
              :hide-selected="true"
              :preserve-search="true"
              placeholder="Insira aqui"
              label="name"
              track-by="name"
              tag-placeholder="Adicionar perfil"
              :taggable="true"
              @tag="addTag"
            />
          </div>
        </div>
      </fieldset>
      -->
      <div style="color:red">* Campos requeridos</div>
    </div>
    <b-button
      class="btn btn-primary btn-lg mr-1"
      type="submit"
      :variant="'success'"
    >{{ user.id == 0 ? 'REGISTRAR' : 'ATUALIZAR'}}</b-button>
    <!-- </div> -->
  </form>
</template>
<script>
import MaskedInput from "vue-text-mask";
import Multiselect from "vue-multiselect";

import UserService from "@/domain/user/UserService";
import BankService from "@/domain/bank/BankService";
import RoleService from "@/domain/role/RoleService";
import User from "@/domain/user/User";
import Bank from "@/domain/bank/Bank";
import Role from "@/domain/role/Role";
import Uf from "@/domain/uf/Uf";

import NotificationProvider from "@/provider/NotificationProvider";

export default {
  name: "user",
  components: {
    MaskedInput,
    Multiselect
  },
  data() {
    return {
      ufs: Uf.ufs,
      user: new User(),
      bank: new Bank(),
      banks: [],
      users: [],
      roles: [],
      bankService: new BankService(),
      userService: new UserService(),
      roleService: new RoleService(),
      notificationProvider: new NotificationProvider(this.$notify),
      mask: {
        cpf: [
          /\d/,
          /\d/,
          /\d/,
          ".",
          /\d/,
          /\d/,
          /\d/,
          ".",
          /\d/,
          /\d/,
          /\d/,
          "-",
          /\d/,
          /\d/
        ],
        address_zipcode: [/\d/, /\d/, /\d/, /\d/, /\d/, "-", /\d/, /\d/, /\d/]
      },
      cepFinish: false,
      process: {
        form: false,
        list: false,
        cep: false
      }
    };
  },
  created() {
    this.process.list = true;
    this.user = JSON.parse(this.$localStorage.get("user"));
    this.bankService.list(999, 1).then(response => {
      this.banks = response;
      this.process.list = false;
    });
  },
  methods: {
    validateBeforeSubmit(scope) {
      this.$validator.validateAll(scope).then(result => {
        if (result) {
          this.process.form = true;
          // EDITAR
          this.userService
            .update(this.user.id, this.user)
            .then(response => {
              this.user = response;
              this.$localStorage.set("user", JSON.stringify(this.user));
              console.log("usuario atualizado");
              this.notificationProvider.success(
                "Usuário atualizado!",
                this.user.name + " atualizado com sucesso"
              );
              this.process.form = false;
            })
            .catch(err => {
              console.log(JSON.stringify(err));
              if (
                err.response &&
                err.response.data &&
                err.response.data.exception &&
                err.response.data.exception ==
                  "Prettus\\Validator\\Exceptions\\ValidatorException"
              ) {
                // alguma validação deu errado
                for (var key in err.response.data.message) {
                  this.notificationProvider.error(
                    "Verificar " + key,
                    err.response.data.message[key][0]
                  );
                }
              } else {
                console.log(JSON.stringify(err));
                this.notificationProvider.error(
                  "Falha ao registrar",
                  "Houve uma falha ao registrar o usuário"
                );
              }
              this.process.form = false;
            });
        }
      });
    },
    consultCep() {
      let cep = this.user.address_zipcode;
      cep = cep.replace("-", "");
      cep = cep.replace("_", "");
      if (cep.length == 8) {
        this.process.cep = true;
        Uf.consultCep(this.user.address_zipcode)
          .then(response => {
            this.user.address_street = response.logradouro;
            this.user.address_neighborhood = response.bairro;
            this.user.address_city = response.localidade;
            this.user.address_state = response.uf;
            this.process.cep = false;
            this.cepFinish = true;
          })
          .catch(err => {
            console.log(JSON.stringify(err));
            this.process.cep = false;
            this.cepFinish = false;
          });
      }
    }
  }
};
</script>
<style>
</style>
